<?php

declare(strict_types=1);

class ModelExtensionPaymentConnectPay extends Model {

  public function getMethod(): array
  {
    $this->load->language('extension/payment/connectpay');

    return [
      'code' => 'connectpay',
      'title' => $this->language->get('text_title'),
      'terms' => '',
      'sort_order' => ''
    ];
  }

  public function getTransactions(): array
  {
    $query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "connectpay_order_transaction`");

    if ($query->num_rows) {
      return $query->rows;
    }

    return [];
  }

  public function getTransactionByOrderId(string $orderId): array
  {
    $query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "connectpay_order_transaction` WHERE `order_id` = '" . (int)$orderId . "' LIMIT 1");

    if ($query->num_rows) {
      return $query->rows;
    }

    return [];
  }

  public function addTransaction(string $paymentId, int $orderId): void
  {
    $this->db->query("INSERT INTO `" . DB_PREFIX . "connectpay_order_transaction` SET `payment_id` = '" . $paymentId . "', `order_id` = '" . $orderId . "', `date_added` = NOW()");
  }

  public function removeTransaction(string $paymentId): void
  {
    $this->db->query("DELETE FROM `" . DB_PREFIX . "connectpay_order_transaction` WHERE `payment_id` = '" . $paymentId . "'");
  }
}
